import axios from 'axios'
import {MessageBox, Message} from 'element-ui'
import store from '@/store'
import {getToken} from '@/utils/auth'

// var _baseURL = "http://localhost:4026";
var _baseURL = "http://139.9.106.207:4026";
var _fileURL = "http://118.31.22.243:80/web/";
// create an axios instance
const service = axios.create({
    baseURL: _baseURL, // url = base url + request url
    // withCredentials: true, // send cookies when cross-domain requests
    timeout: 1000000 // request timeout
});

// request interceptor
service.interceptors.request.use(
    config => {
        // do something before request is sent
        if (store.getters.token) {
            // let each request carry token
            // ['X-Token'] is a custom headers key
            // please modify it according to the actual situation
            config.headers['Authorization'] = getToken()
        }
        return config
    },
    error => {
        // do something with request error
        return Promise.reject(error)
    }
)

// response interceptor
service.interceptors.response.use(
    /**
     * If you want to get http information such as headers or status
     * Please return  response => response
     */

    /**
     * Determine the request status by custom code
     * Here is just an example
     * You can also judge the status by HTTP Status Code
     */
    response => {
        const res = response.data

        // if the custom code is not 20000, it is judged as an error.
        if (res.code !== "SUCCESS") {
            Message({
                message: res.msg || '系统错误',
                type: 'error',
                duration: 5 * 1000
            })

            if (res.code == "UNAUTHORIZED") {
                store.dispatch('user/resetToken').then(() => {
                    location.reload()
                })
            }

            return Promise.reject(new Error(res.message || 'Error'))
        } else {
            return res
        }
    },
    error => {
        Message({
            message: error.message,
            type: 'error',
            duration: 5 * 1000
        })
        return Promise.reject(error)
    }
)

export default service;

// return url prefix
export function getBaseUrl() {
    return _baseURL;
}

export function getFileUrl() {
    return _fileURL;
}

